diff --git a/arch/ppc/platforms/ibm440gx.c b/arch/ppc/platforms/ibm440gx.c
--- a/arch/ppc/platforms/ibm440gx.c
+++ b/arch/ppc/platforms/ibm440gx.c
@@ -4,10 +4,10 @@
  * PPC440GX I/O descriptions
  *
  * Matt Porter <mporter@mvista.com>
- * Copyright 2002-2003 MontaVista Software Inc.
+ * Copyright 2002-2004 MontaVista Software Inc.
  *
  * Eugene Surovegin <eugene.surovegin@zultys.com> or <ebs@ebshome.net>
- * Copyright (c) 2003 Zultys Technologies
+ * Copyright (c) 2003, 2004 Zultys Technologies
  *
  * This program is free software; you can redistribute  it and/or modify it
  * under  the terms of  the GNU General  Public License as published by the
@@ -19,44 +19,76 @@
 #include <linux/module.h>
 #include <platforms/ibm440gx.h>
 #include <asm/ocp.h>
-
-#if defined(EMAC_NUMS) && EMAC_NUMS > 0
-u32 emac_phy_map[EMAC_NUMS];
-EXPORT_SYMBOL(emac_phy_map);
-#endif
+#include <asm/ppc4xx_pic.h>
 
 static struct ocp_func_emac_data ibm440gx_emac0_def = {
+	.rgmii_idx	= -1,		/* No RGMII */
+	.rgmii_mux	= -1,		/* No RGMII */
 	.zmii_idx       = 0,            /* ZMII device index */
 	.zmii_mux       = 0,            /* ZMII input of this EMAC */
 	.mal_idx        = 0,            /* MAL device index */
 	.mal_rx_chan    = 0,            /* MAL rx channel number */
-	.mal_tx1_chan   = 0,            /* MAL tx channel 1 number */
-	.mal_tx2_chan   = -1,           /* MAL tx channel 2 number */
-	.wol_irq        = BL_MAC_WOL,   /* WOL interrupt number */
+	.mal_tx_chan    = 0,            /* MAL tx channel number */
+	.wol_irq        = 61,   	/* WOL interrupt number */
 	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= -1,		/* No TAH */
 };
 
 static struct ocp_func_emac_data ibm440gx_emac1_def = {
+	.rgmii_idx	= -1,		/* No RGMII */
+	.rgmii_mux	= -1,		/* No RGMII */
 	.zmii_idx       = 0,            /* ZMII device index */
 	.zmii_mux       = 1,            /* ZMII input of this EMAC */
 	.mal_idx        = 0,            /* MAL device index */
 	.mal_rx_chan    = 1,            /* MAL rx channel number */
-	.mal_tx1_chan   = 1,            /* MAL tx channel 1 number */
-	.mal_tx2_chan   = -1,           /* MAL tx channel 2 number */
-	.wol_irq        = BL_MAC_WOL1,   /* WOL interrupt number */
+	.mal_tx_chan    = 1,            /* MAL tx channel number */
+	.wol_irq        = 63,  		/* WOL interrupt number */
 	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= -1,		/* No TAH */
+};
+
+static struct ocp_func_emac_data ibm440gx_emac2_def = {
+	.rgmii_idx	= 0,		/* RGMII device index */
+	.rgmii_mux	= 0,		/* RGMII input of this EMAC */
+	.zmii_idx       = 0,            /* ZMII device index */
+	.zmii_mux       = 2,            /* ZMII input of this EMAC */
+	.mal_idx        = 0,            /* MAL device index */
+	.mal_rx_chan    = 2,            /* MAL rx channel number */
+	.mal_tx_chan    = 2,            /* MAL tx channel number */
+	.wol_irq        = 65,  		/* WOL interrupt number */
+	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= 0,		/* TAH device index */
+};
+
+static struct ocp_func_emac_data ibm440gx_emac3_def = {
+	.rgmii_idx	= 0,		/* RGMII device index */
+	.rgmii_mux	= 1,		/* RGMII input of this EMAC */
+	.zmii_idx       = 0,            /* ZMII device index */
+	.zmii_mux       = 3,            /* ZMII input of this EMAC */
+	.mal_idx        = 0,            /* MAL device index */
+	.mal_rx_chan    = 3,            /* MAL rx channel number */
+	.mal_tx_chan    = 3,            /* MAL tx channel number */
+	.wol_irq        = 67,  		/* WOL interrupt number */
+	.mdio_idx       = -1,           /* No shared MDIO */
+	.tah_idx	= 1,		/* TAH device index */
 };
 
 static struct ocp_func_mal_data ibm440gx_mal0_def = {
-	.num_tx_chans   = 2*EMAC_NUMS,  /* Number of TX channels */
-	.num_rx_chans   = EMAC_NUMS,    /* Number of RX channels */
+	.num_tx_chans   = 4,    	/* Number of TX channels */
+	.num_rx_chans   = 4,    	/* Number of RX channels */
+	.dcr_base	= DCRN_MAL_BASE,
+	.txeob_irq	= 10,		/* TX End Of Buffer IRQ  */
+	.rxeob_irq	= 11,		/* RX End Of Buffer IRQ  */
+	.txde_irq	= 33,		/* TX Descriptor Error IRQ */
+	.rxde_irq	= 34,		/* RX Descriptor Error IRQ */
+	.serr_irq	= 32,		/* MAL System Error IRQ    */
 };
 
-struct ocp_def core_ocp[] __initdata = {
+struct ocp_def core_ocp[] = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_OPB,
 	  .index	= 0,
-	  .paddr	= PPC440GX_OPB_BASE_START,
+	  .paddr	= 0x0000000140000000ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= OCP_CPM_NA,
 	},
@@ -77,21 +109,21 @@ struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_IIC,
 	  .index	= 0,
-	  .paddr	= PPC440GX_IIC0_ADDR,
-	  .irq		= IIC0_IRQ,
+	  .paddr	= 0x0000000140000400ULL,
+	  .irq		= 2,
 	  .pm		= IBM_CPM_IIC0,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_IIC,
 	  .index	= 1,
-	  .paddr	= PPC440GX_IIC1_ADDR,
-	  .irq		= IIC1_IRQ,
+	  .paddr	= 0x0000000140000500ULL,
+	  .irq		= 3,
 	  .pm		= IBM_CPM_IIC1,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_GPIO,
 	  .index	= 0,
-	  .paddr	= PPC440GX_GPIO0_ADDR,
+	  .paddr	= 0x0000000140000700ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= IBM_CPM_GPIO0,
 	},
@@ -105,25 +137,77 @@ struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 0,
-	  .paddr	= PPC440GX_EMAC0_ADDR,
-	  .irq		= BL_MAC_ETH0,
+	  .paddr	= 0x0000000140000800ULL,
+	  .irq		= 60,
 	  .pm		= OCP_CPM_NA,
 	  .additions	= &ibm440gx_emac0_def,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 1,
-	  .paddr	= PPC440GX_EMAC1_ADDR,
-	  .irq		= BL_MAC_ETH1,
+	  .paddr	= 0x0000000140000900ULL,
+	  .irq		= 62,
 	  .pm		= OCP_CPM_NA,
 	  .additions	= &ibm440gx_emac1_def,
 	},
 	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_EMAC,
+	  .index	= 2,
+	  .paddr	= 0x0000000140000C00ULL,
+	  .irq		= 64,
+	  .pm		= OCP_CPM_NA,
+	  .additions	= &ibm440gx_emac2_def,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_EMAC,
+	  .index	= 3,
+	  .paddr	= 0x0000000140000E00ULL,
+	  .irq		= 66,
+	  .pm		= OCP_CPM_NA,
+	  .additions	= &ibm440gx_emac3_def,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_RGMII,
+	  .paddr	= 0x0000000140000790ULL,
+	  .irq		= OCP_IRQ_NA,
+	  .pm		= OCP_CPM_NA,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_ZMII,
-	  .paddr	= PPC440GX_ZMII_ADDR,
+	  .paddr	= 0x0000000140000780ULL,
 	  .irq		= OCP_IRQ_NA,
 	  .pm		= OCP_CPM_NA,
 	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_TAH,
+	  .index	= 0,
+	  .paddr	= 0x0000000140000b50ULL,
+	  .irq		= 68,
+	  .pm		= OCP_CPM_NA,
+	},
+	{ .vendor	= OCP_VENDOR_IBM,
+	  .function	= OCP_FUNC_TAH,
+	  .index	= 1,
+	  .paddr	= 0x0000000140000d50ULL,
+	  .irq		= 69,
+	  .pm		= OCP_CPM_NA,
+	},
 	{ .vendor	= OCP_VENDOR_INVALID
 	}
 };
+
+/* Polarity and triggering settings for internal interrupt sources */
+struct ppc4xx_uic_settings ppc4xx_core_uic_cfg[] __initdata = {
+	{ .polarity 	= 0xfffffe03,
+	  .triggering	= 0x01c00000,
+	  .ext_irq_mask	= 0x000001fc,	/* IRQ0 - IRQ6 */
+	},
+	{ .polarity 	= 0xffffc0ff,
+	  .triggering	= 0x00ff8000,
+	  .ext_irq_mask	= 0x00003f00,	/* IRQ7 - IRQ12 */
+	},
+	{ .polarity 	= 0xffff83ff,
+	  .triggering	= 0x000f83c0,
+	  .ext_irq_mask	= 0x00007c00,	/* IRQ13 - IRQ17 */
+	},
+};
diff --git a/arch/ppc/platforms/ibm440gx.h b/arch/ppc/platforms/ibm440gx.h
--- a/arch/ppc/platforms/ibm440gx.h
+++ b/arch/ppc/platforms/ibm440gx.h
@@ -12,7 +12,7 @@
  * under  the terms of  the GNU General  Public License as published by the
  * Free Software Foundation;  either version 2 of the  License, or (at your
  * option) any later version.
- * 
+ *
  */
 
 #ifdef __KERNEL__
@@ -24,56 +24,11 @@
 #include <asm/ibm44x.h>
 
 /* UART */
-#define PPC440GX_UART0_ADDR	0x0000000140000200
-#define PPC440GX_UART1_ADDR	0x0000000140000300
+#define PPC440GX_UART0_ADDR	0x0000000140000200ULL
+#define PPC440GX_UART1_ADDR	0x0000000140000300ULL
 #define UART0_INT		0
 #define UART1_INT		1
 
-/* EMAC */
-#define PPC440GX_EMAC0_ADDR	0x0000000140000800
-#define PPC440GX_EMAC1_ADDR	0x0000000140000900
-#define PPC440GX_EMAC2_ADDR	0x0000000140000C00
-#define PPC440GX_EMAC3_ADDR	0x0000000140000E00
-#define PPC440GX_EMAC_SIZE	0xFC
-#define EMAC_NUMS               2
-#define BL_MAC_WOL	61	/* WOL */
-#define BL_MAC_WOL1	63	/* WOL */
-#define BL_MAC_WOL2	65	/* WOL */
-#define BL_MAC_WOL3	67	/* WOL */
-#define BL_MAL_SERR	32	/* MAL SERR */
-#define BL_MAL_TXDE	33	/* MAL TXDE */
-#define BL_MAL_RXDE	34	/* MAL RXDE */
-#define BL_MAL_TXEOB	10	/* MAL TX EOB */
-#define BL_MAL_RXEOB	11	/* MAL RX EOB */
-#define BL_MAC_ETH0	60	/* MAC */
-#define BL_MAC_ETH1	62	/* MAC */
-#define BL_MAC_ETH2	64	/* MAC */
-#define BL_MAC_ETH3	66	/* MAC */
-#define BL_TAH0		68	/* TAH 0 */
-#define BL_TAH1		69	/* TAH 1 */
-
-/* TAH */
-#define PPC440GX_TAH0_ADDR	0x0000000140000B00
-#define PPC440GX_TAH1_ADDR	0x0000000140000D00
-#define PPC440GX_TAH_SIZE	0xFC
-
-/* ZMII */
-#define PPC440GX_ZMII_ADDR	0x0000000140000780
-#define PPC440GX_ZMII_SIZE	0x0c
-
-/* RGMII */
-#define PPC440GX_RGMII_ADDR	0x0000000140000790
-#define PPC440GX_RGMII_SIZE	0x0c
-
-/* IIC  */
-#define PPC440GX_IIC0_ADDR	0x40000400
-#define PPC440GX_IIC1_ADDR	0x40000500
-#define IIC0_IRQ		2
-#define IIC1_IRQ		3
-
-/* GPIO */
-#define PPC440GX_GPIO0_ADDR	0x0000000140000700
-
 /* Clock and Power Management */
 #define IBM_CPM_IIC0		0x80000000	/* IIC interface */
 #define IBM_CPM_IIC1		0x40000000	/* IIC interface */
@@ -109,11 +64,7 @@
 				| IBM_CPM_TMRCLK | IBM_CPM_DMA | IBM_CPM_PCI \
 				| IBM_CPM_TAHOE0 | IBM_CPM_TAHOE1 \
 				| IBM_CPM_EMAC0 | IBM_CPM_EMAC1 \
-			  	| IBM_CPM_EMAC2 | IBM_CPM_EMAC3 )	
-
-/* OPB */
-#define PPC440GX_OPB_BASE_START	0x0000000140000000
-
+			  	| IBM_CPM_EMAC2 | IBM_CPM_EMAC3 )
 /*
  * Serial port defines
  */
diff --git a/arch/ppc/platforms/ibmstbx25.c b/arch/ppc/platforms/ibmstbx25.c
--- a/arch/ppc/platforms/ibmstbx25.c
+++ b/arch/ppc/platforms/ibmstbx25.c
@@ -1,42 +1,18 @@
 /*
+ * arch/ppc/platforms/4xx/ibmstbx25.c
  *
- *    Copyright 2000-2002 MontaVista Software Inc.
- *      Completed implementation.
- *	Current maintainer
- *      Armin Kuster akuster@mvista.com
- *
- *    Module name: ibmstbx25.c
- *
- *
- * This program is free software; you can redistribute  it and/or modify it
- *  under  the terms of  the GNU General Public License as published by the
- *  Free Software Foundation;  either version 2 of the  License, or (at your
- *  option) any later version.
- *
- *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR   IMPLIED
- *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
- *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
- *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
- *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
- *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
- *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
- *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
- *  You should have received a copy of the  GNU General Public License along
- *  with this program; if not, write  to the Free Software Foundation, Inc.,
- *  675 Mass Ave, Cambridge, MA 02139, USA.
- *
- *      History: July 10, 2002 - armin
- *		initial release
- *
+ * Author: Armin Kuster <akuster@mvista.com>
  *
+ * 2000-2002 (c) MontaVista, Software, Inc.  This file is licensed under
+ * the terms of the GNU General Public License version 2.  This program
+ * is licensed "as is" without any warranty of any kind, whether express
+ * or implied.
  */
 
 #include <linux/init.h>
 #include <platforms/ibmstbx25.h>
 #include <asm/ocp.h>
+#include <asm/ppc4xx_pic.h>
 
 struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_IBM,
@@ -75,3 +51,11 @@ struct ocp_def core_ocp[] __initdata = {
 	{ .vendor	= OCP_VENDOR_INVALID
 	}
 };
+
+/* Polarity and triggering settings for internal interrupt sources */
+struct ppc4xx_uic_settings ppc4xx_core_uic_cfg[] __initdata = {
+	{ .polarity 	= 0xffff8f80,
+	  .triggering	= 0x00000000,
+	  .ext_irq_mask	= 0x0000707f,	/* IRQ7 - IRQ9, IRQ0 - IRQ6 */
+	}
+};
diff --git a/arch/ppc/platforms/ocotea.c b/arch/ppc/platforms/ocotea.c
--- a/arch/ppc/platforms/ocotea.c
+++ b/arch/ppc/platforms/ocotea.c
@@ -43,6 +43,7 @@
 #include <asm/todc.h>
 #include <asm/bootinfo.h>
 #include <asm/ppc4xx_pic.h>
+#include <asm/ocp.h>
 
 #include <kernel/ibm440gx_common.h>
 
@@ -81,10 +82,9 @@ ocotea_calibrate_decr(void)
 static int
 ocotea_show_cpuinfo(struct seq_file *m)
 {
-	ibm440gx_show_cpuinfo(m);
 	seq_printf(m, "vendor\t\t: IBM\n");
 	seq_printf(m, "machine\t\t: PPC440GX EVB (Ocotea)\n");
-
+	ibm440gx_show_cpuinfo(m);
 	return 0;
 }
 
@@ -108,13 +108,13 @@ ocotea_map_irq(struct pci_dev *dev, unsi
 }
 
 #define PCIX_READW(offset) \
-	(readw((u32)pcix_reg_base+offset))
+	(readw(pcix_reg_base+offset))
 
 #define PCIX_WRITEW(value, offset) \
-	(writew(value, (u32)pcix_reg_base+offset))
+	(writew(value, pcix_reg_base+offset))
 
 #define PCIX_WRITEL(value, offset) \
-	(writel(value, (u32)pcix_reg_base+offset))
+	(writel(value, pcix_reg_base+offset))
 
 /*
  * FIXME: This is only here to "make it work".  This will move
@@ -257,18 +257,41 @@ ocotea_setup_arch(void)
 	unsigned long long mac64;
 	bd_t *bip = (bd_t *) __res;
 	struct ibm44x_clocks clocks;
+	int i;
 
 	/* Retrieve MAC addresses from flash */
 	addr = ioremap64(OCOTEA_MAC_BASE, OCOTEA_MAC_SIZE);
 	mac64 = simple_strtoull(addr, 0, 16);
 	memcpy(bip->bi_enetaddr[0], (char *)&mac64+2, 6);
-	mac64 = simple_strtoull(addr+OCOTEA_MAC1_OFFSET, 0, 16);
+	mac64 = simple_strtoull(addr + OCOTEA_MAC_OFFSET, 0, 16);
 	memcpy(bip->bi_enetaddr[1], (char *)&mac64+2, 6);
+	mac64 = simple_strtoull(addr + OCOTEA_MAC_OFFSET * 2, 0, 16);
+	memcpy(bip->bi_enetaddr[2], (char *)&mac64+2, 6);
+	mac64 = simple_strtoull(addr + OCOTEA_MAC_OFFSET * 3, 0, 16);
+	memcpy(bip->bi_enetaddr[3], (char *)&mac64+2, 6);
 	iounmap(addr);
 
 	/* Set EMAC PHY map to not probe address 0x00 */
-	emac_phy_map[0] = 0x00000001;
-	emac_phy_map[1] = 0x00000001;
+	for (i = 0; i < 4; ++i) {
+		struct ocp_def *def;
+		def = ocp_get_one_device(OCP_VENDOR_IBM, OCP_FUNC_EMAC, i);
+		if (def){
+			struct ocp_func_emac_data *emacdata = def->additions;
+			
+			if (i < 2) {
+				/* Skip 0x00 */
+				emacdata->phy_map = 0x00000001;	
+				emacdata->phy_mode = PHY_MODE_SMII;
+			}
+			else {
+				/* Skip 0x00-0x0f */
+				emacdata->phy_map = 0x0000ffff; 
+				emacdata->phy_mode = PHY_MODE_RGMII;
+			}
+		}
+	}
+	
+	ibm440gx_tah_enable();
 
 #if !defined(CONFIG_BDI_SWITCH)
 	/*
@@ -285,6 +308,7 @@ ocotea_setup_arch(void)
 	 */
 	ibm440gx_get_clocks(&clocks, 33333333, 6 * 1843200);
 	bip->bi_opb_busfreq = clocks.opb;
+	ocp_sys_info.opb_bus_freq = clocks.opb;
 	
 	/* Use IIC in standard (100 kHz) mode */
 	bip->bi_iic_fast[0] = bip->bi_iic_fast[1] = 0;
@@ -403,20 +427,6 @@ ocotea_find_end_of_memory(void)
 	return mem_size;
 }
 
-static void __init
-ocotea_init_irq(void)
-{
-	int i;
-
-	/* Enable PPC440GP interrupt compatibility mode */
-	SDR_WRITE(DCRN_SDR_MFR,SDR_READ(DCRN_SDR_MFR) | DCRN_SDR_MFR_PCM);
-
-	ppc4xx_pic_init();
-
-	for (i = 0; i < NR_IRQS; i++)
-		irq_desc[i].handler = ppc4xx_pic;
-}
-
 void __init platform_init(unsigned long r3, unsigned long r4,
 		unsigned long r5, unsigned long r6, unsigned long r7)
 {
@@ -427,7 +437,7 @@ void __init platform_init(unsigned long 
 
 	ppc_md.setup_arch = ocotea_setup_arch;
 	ppc_md.show_cpuinfo = ocotea_show_cpuinfo;
-	ppc_md.init_IRQ = ocotea_init_irq;
+	ppc_md.init_IRQ = ppc4xx_pic_init;
 	ppc_md.get_irq = NULL;		/* Set in ppc4xx_pic_init() */
 
 	ppc_md.find_end_of_memory = ocotea_find_end_of_memory;
diff --git a/arch/ppc/platforms/ocotea.h b/arch/ppc/platforms/ocotea.h
--- a/arch/ppc/platforms/ocotea.h
+++ b/arch/ppc/platforms/ocotea.h
@@ -27,7 +27,7 @@
 /* Location of MAC addresses in firmware */
 #define OCOTEA_MAC_BASE		(OCOTEA_SMALL_FLASH_HIGH+0xb0500)
 #define OCOTEA_MAC_SIZE		0x200
-#define OCOTEA_MAC1_OFFSET	0x100
+#define OCOTEA_MAC_OFFSET	0x100
 
 /* Default clock rate */
 #define OCOTEA_SYSCLK		25000000
diff --git a/arch/ppc/platforms/redwood6.c b/arch/ppc/platforms/redwood6.c
--- a/arch/ppc/platforms/redwood6.c
+++ b/arch/ppc/platforms/redwood6.c
@@ -47,42 +47,19 @@
 
 
 /*
- * Define all of the IRQ senses and polarities.  
+ * Define external IRQ senses and polarities.
  */
-
-static u_char redwood6_IRQ_initsenses[] __initdata = {
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 0: RTC/FPC */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 1: Transport */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 2: Audio Dec */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 3: Video Dec */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 4: DMA Chan 0 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 5: DMA Chan 1 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 6: DMA Chan 2 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 7: DMA Chan 3 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 8: SmartCard 0 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 9: IIC0 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 10: IRR */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 11: Cap Timers */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 12: Cmp Timers */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 13: Serial Port */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 14: Soft Modem */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 15: Down Ctrs */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 16: SmartCard 1 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 17: Ext Int 7 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 18: Ext Int 8 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 19: Ext Int 9 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 20: Serial 0 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 21: Serial 1 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 22: Serial 2 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 23: XPT_DMA */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_POSITIVE),	/* 24: DCR timeout */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 25: Ext Int 0 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 26: Ext Int 1 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 27: Ext Int 2 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 28: Ext Int 3 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 29: Ext Int 4 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 30: Ext Int 5 */
-	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* 31: Ext Int 6 */
+unsigned char ppc4xx_uic_ext_irq_cfg[] __initdata = {
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 7 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 8 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 9 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 0 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 1 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 2 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 3 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 4 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 5 */
+	(IRQ_SENSE_LEVEL | IRQ_POLARITY_NEGATIVE),	/* Ext Int 6 */
 };
 
 
@@ -136,8 +113,6 @@ board_setup_arch(void)
 
 	printk("\n");
 #endif
-	ibm4xxPIC_InitSenses = redwood6_IRQ_initsenses;
-	ibm4xxPIC_NumInitSenses = sizeof(redwood6_IRQ_initsenses);
 
 	/* Identify the system */
 	printk(KERN_INFO "IBM Redwood6 (STBx25XX) Platform\n");
diff --git a/drivers/net/Makefile b/drivers/net/Makefile
--- a/drivers/net/Makefile
+++ b/drivers/net/Makefile
@@ -25,8 +25,6 @@ ifeq ($(CONFIG_TULIP),y)
   obj-y += tulip/tulip.o
 endif
 
-obj-$(CONFIG_OCP_NET) += ibm_emac/ocp.o
-
 ifeq ($(CONFIG_E1000),y)
   obj-y += e1000/e1000.o
 endif
@@ -42,7 +40,6 @@ endif
 subdir-$(CONFIG_NET_PCMCIA) += pcmcia
 subdir-$(CONFIG_NET_WIRELESS) += wireless
 subdir-$(CONFIG_TULIP) += tulip
-subdir-$(CONFIG_OCP_NET) += ibm_emac
 subdir-$(CONFIG_IRDA) += irda
 subdir-$(CONFIG_TR) += tokenring
 subdir-$(CONFIG_WAN) += wan
@@ -243,6 +240,9 @@ obj-$(CONFIG_DL2K) += dl2k.o
 obj-$(CONFIG_R8169) += r8169.o
 obj-$(CONFIG_AMD8111_ETH) += amd8111e.o mii.o
 
+subdir-$(CONFIG_IBM_EMAC) += ibm_emac
+obj-$(CONFIG_IBM_EMAC) += ibm_emac/ibm_emac.o
+
 # non-drivers/net drivers who want mii lib
 obj-$(CONFIG_PCMCIA_SMC91C92) += mii.o
 obj-$(CONFIG_USB_USBNET) += mii.o
diff --git a/drivers/net/ibm_emac/Config.in b/drivers/net/ibm_emac/Config.in
--- a/drivers/net/ibm_emac/Config.in
+++ b/drivers/net/ibm_emac/Config.in
@@ -4,20 +4,24 @@
 mainmenu_option next_comment
 comment 'On-chip net devices'
 if [ "$CONFIG_IBM_OCP" = "y" ]; then
-   bool '  IBM on-chip ethernet' CONFIG_IBM_OCP_ENET
-   if [ "$CONFIG_IBM_OCP_ENET" = "y" ]; then
-      bool '    Verbose error messages' CONFIG_IBM_OCP_ENET_ERROR_MSG
-      int '    Number of receive buffers' CONFIG_IBM_OCP_ENET_RX_BUFF 64
-      int '    Number of transmit buffers' CONFIG_IBM_OCP_ENET_TX_BUFF 8
-      int '    Frame gap' CONFIG_IBM_OCP_ENET_GAP 8
-      int '    Skb reserve amount' CONFIG_IBM_OCP_ENET_SKB_RES 0
-   fi
-   if [ "$CONFIG_IBM_OCP_ENET" = "y" ]; then
-      define_bool CONFIG_OCP_NET y
-      if [ "$CONFIG_NP405H" = "y" -o  "$CONFIG_NP405L" = "y"	\
-	   -o "$CONFIG_440" = "y" ]; then
-	 define_int CONFIG_IBM_OCP_MAL_CNT 1
-	 define_bool CONFIG_IBM_OCP_ZMII  y
+   tristate '  IBM on-chip ethernet' CONFIG_IBM_EMAC
+   if [ "$CONFIG_IBM_EMAC" = "y" -o "$CONFIG_IBM_EMAC" = "m" ]; then
+      int '    Number of receive buffers' CONFIG_IBM_EMAC_RXB 128
+      int '    Number of transmit buffers' CONFIG_IBM_EMAC_TXB 32
+      int '    MAL NAPI polling weight' CONFIG_IBM_EMAC_POLL_WEIGHT 32
+      int '    RX skb copy threshold' CONFIG_IBM_EMAC_RX_COPY_THRESHOLD 256
+      int '    Additional RX skb headroom (bytes)' CONFIG_IBM_EMAC_RX_SKB_HEADROOM 0
+      if [ "$CONFIG_405EP" = "y" -o "$CONFIG_440GX" = "y" ]; then
+         bool '    PHY Rx clock workaround' CONFIG_IBM_EMAC_PHY_RX_CLK_FIX
+      fi
+      bool '    Debugging' CONFIG_IBM_EMAC_DEBUG
+      
+      if [ "$CONFIG_44x" = "y" ]; then
+	 define_bool CONFIG_IBM_EMAC_ZMII  y
+      fi
+      if [ "$CONFIG_440GX" = "y" ]; then
+	 define_bool CONFIG_IBM_EMAC_RGMII  y
+	 define_bool CONFIG_IBM_EMAC_TAH    y
       fi
    fi
 fi
diff --git a/drivers/net/ibm_emac/Makefile b/drivers/net/ibm_emac/Makefile
--- a/drivers/net/ibm_emac/Makefile
+++ b/drivers/net/ibm_emac/Makefile
@@ -1,26 +1,14 @@
 #
-# Makefile for the On-chip  ethernet drivers
+# Makefile for the PowerPC 4xx on-chip ethernet driver
 #
-# Note! Dependencies are done automagically by 'make dep', which also
-# removes any old dependencies. DON'T put your own dependencies here
-# unless it's something special (ie not a .c file).
-#
-# Note 2! The CFLAGS definitions are now in the main makefile...
-
-
-obj-y   := 
-obj-m   := 
-
-O_TARGET := ocp.o
-
-# Module support doesn't work yet.
-export-objs     := 
+O_TARGET := ibm_emac.o
 
-obj-$(CONFIG_IBM_OCP_ENET) += ibm_ocp_enet.o ibm_ocp_phy.o ibm_ocp_mal.o
+obj-y := ibm_emac_mal.o ibm_emac_core.o ibm_emac_phy.o 
+obj-$(CONFIG_IBM_EMAC_ZMII) += ibm_emac_zmii.o
+obj-$(CONFIG_IBM_EMAC_RGMII) += ibm_emac_rgmii.o
+obj-$(CONFIG_IBM_EMAC_TAH) += ibm_emac_tah.o
+obj-$(CONFIG_IBM_EMAC_DEBUG) += ibm_emac_debug.o
 
-# Only need this if you want to see additional debug messages
-ifeq ($(CONFIG_IBM_OCP_ENET_ERROR_MSG), y)
-obj-$(CONFIG_IBM_OCP_ENET) += ibm_ocp_debug.o
-endif
+obj-m := $(O_TARGET)
 
 include $(TOPDIR)/Rules.make
